package cn.iocoder.yudao.module.mes.dal.mysql.zjschema;

import java.util.*;
import java.util.stream.Collectors;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.common.dal.dataobject.moldrepair.MoldRepairDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.zjschema.ZjSchemaDO;
import com.alibaba.excel.util.StringUtils;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.mes.controller.admin.zjschema.vo.*;

/**
 * 检验方案 Mapper
 *
 * @author 内蒙必硕
 */
@Mapper
public interface ZjSchemaMapper extends BaseMapperX<ZjSchemaDO> {

    default PageResult<ZjSchemaDO> selectPage(ZjSchemaPageReqVO reqVO) {
        LambdaQueryWrapperX<ZjSchemaDO> zjSchemaDOLambdaQueryWrapperX = new LambdaQueryWrapperX<>();
        zjSchemaDOLambdaQueryWrapperX
                .eqIfPresent(ZjSchemaDO::getType, reqVO.getType())
                .likeIfPresent(ZjSchemaDO::getName, reqVO.getName())
                .eqIfPresent(ZjSchemaDO::getRemark, reqVO.getRemark())
                .eqIfPresent(ZjSchemaDO::getSampleMethod, reqVO.getSampleMethod())
                .eqIfPresent(ZjSchemaDO::getVal, reqVO.getVal())
                .eqIfPresent(ZjSchemaDO::getItem, reqVO.getItem())
                .betweenIfPresent(ZjSchemaDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(ZjSchemaDO::getId);

        if (StringUtils.isNotBlank(reqVO.getIds())) {
            List<Long> idList = Arrays.stream(reqVO.getIds().split(","))
                    .map(String::trim)
                    .map(Long::valueOf)
                    .collect(Collectors.toList());
            zjSchemaDOLambdaQueryWrapperX.in(ZjSchemaDO::getId, idList);
        }

        return selectPage(reqVO, zjSchemaDOLambdaQueryWrapperX);
    }



    default ZjSchemaDO selectByName(String name) {
        return selectOne(new LambdaQueryWrapperX<ZjSchemaDO>()
                .eq(ZjSchemaDO::getName, name));
    }

    default List<ZjSchemaDO> selectByType(String type) {
        return selectList(new LambdaQueryWrapperX<ZjSchemaDO>()
                .eq(ZjSchemaDO::getType, type)
                .orderByAsc(ZjSchemaDO::getId));
    }

}